/******************************************************************************
 * Includes
 *****************************************************************************/

#include "general.h"
#include <lpc2xxx.h>
#include <printf_P.h>
#include <ea_init.h>
#include <framework.h>
#include <string.h>

char string[] = "What is the length of this string?";

void initTimer()
{
	TIMER0_TCR = 2; // Stop and reset timer
	TIMER0_PR  = 0; // increment TC every PCLK
	TIMER0_MCR = 0; // Do not stop, reset or interrupt on any match
	TIMER0_TCR = 1; // Start timer
}

unsigned getTimer()
{
	return TIMER0_TC;
}

unsigned function(char *str)
{
	unsigned length = 0;
	while (*str)
	{
		str++;
		length++;
	}
	return length;
}

main()
{
	tU32 start;
	tU32 end;
	volatile tU32 temp;
	volatile tU32 temp2;

	eaInit();
	printf("**********************************\n");
	printf("*                                *\n");
	printf("* Timing your program, example 1 *\n");
	printf("* (c) 2005, Rob Jansen           *\n");
	printf("*                                *\n");
	printf("**********************************\n");

	initTimer();

	start = getTimer();
	end   = getTimer();

	printf("1: Timer ran from %u to %u (diff = %u)\n", start, end, end-start);

	start = getTimer();
	temp  = 1;
	end   = getTimer();

	printf("2: Timer ran from %u to %u (diff = %u)\n", start, end, end-start);

	start = getTimer();
	temp2 = function(string);
	temp  = getTimer();
	temp2 = strlen(string);
	end   = getTimer();

	printf("3: Timer ran from %u via %u to %u (diff = %u, %u)\n", start, temp, end, temp-start, end-temp);
}